function exp00600_relatorio_consumo_na_expedicao_Controller(templateManager, restEngine, General, ScreenService, ZhFilterPreferences, ZHPromise,MessageService){
	var somadorFields = 3;//4->NOTAFIS, 5->NRPEDIDO
	
	var verificadorFields = {
		"CDFILIAL": false,
		"DATAINICIAL": false,
		"CDCLIENTE": true,
		"TIPOOPER": true,
		"NOTAFIS": true
	};
	
	this.filterOnEnter = function(widget){
        var promises = [];
        promises.push(ZhFilterPreferences.setOriginalFilter(widget.id));
        promises.push(ZhFilterPreferences.openFilterWidget(widget));
        ZHPromise.all(promises).then(function(rowSetFilter){
            this.setFilter();
        }.bind(this)); 
    };
	
	this.setFilter= function(){
	    var row = templateManager.container.getActiveWidget().currentRow;
	    General.callRestEngine('ped#/crud/filial', 'FilterData', [{name: 'CDFILIAL', operator: '=', value: 'FILIAL_LOGADA'}]).then(function(response) {
            row.CDFILIAL = response.dataset.filial[0].CDFILIAL;
            row.NMFILIAL = response.dataset.filial[0].NMFILIAL;
	    });
	    var NDate = new Date();
        var today = NDate.getDate() + "/" + parseInt(NDate.getMonth()+1)+ "/" + NDate.getFullYear();
        var interval = {
            "end" : today,
            "period" : undefined,
            "start" : today
        };
        
        row.DTEXPEDICAO = interval;
	};
    /*this.filterBuilder = function () {
        var activeWidget = templateManager.container.getActiveWidget();
        var nome;
        var exp = /\b(NM|DT|NRL)[A-Z];*///nao precisam ser montados no filtro
        /*var exp1 = /\b(CDCLIENTE|TIPOOPER|NOTAFIS|NRPEDIDO|CDVENDEDOR)/;//montados no filtro com operador IN
        var exp2 = /\b(TODOS|TODAS)/;//Campos que precisam passar o filtro "T" mesmo quando não preenchidos
        templateManager.container.getWidget('relatorio_consumo_expedicao').dataSourceFilter = [];
        
        templateManager.container.getWidget('relatorio_consumo_expedicao').dataSourceFilter.push(
        	{
        		"name": "P_PRODFIM",
        		"operator": "=",
        		"value": activeWidget.currentRow.CDPRODUTO
        	}
        );
        
        activeWidget.fields.forEach(function (field) {
        	
            if(field.value() != "" && field.value() != null && !field.name.match(exp) && field.name != 'SEARCHLIST__ALL') {
                nome = nomes[field.name];
	               
	            if(field.name.match(exp1)){
	            	templateManager.container.getWidget('relatorio_consumo_expedicao').dataSourceFilter.push(
	                    {
	                        "name": nome,
	                        "operator": "IN",
	                        "value": field.value().join(',')
	                    }
	                );
	            } else{
	                templateManager.container.getWidget('relatorio_consumo_expedicao').dataSourceFilter.push(
	                    {
	                        "name":  nome,
	                        "operator": "=",
	                        "value": field.value()
	                    }
	                );
	            }
            } else if(field.value() === undefined && field.name.match(exp2)){
            	nome = nomes[field.name];
            	templateManager.container.getWidget('relatorio_consumo_expedicao').dataSourceFilter.push(
	                {
	                    "name":  nome,
	                    "operator": "=",
	                    "value": "T"
	                }
	            );
            }
        });
    };*/
    
    this.filterCDARVPRODFIN = function() {
    	var prodIni = templateManager.container.getActiveWidget().getField('CDARVPRODINI');
    	var prodFin = templateManager.container.getActiveWidget().getField('CDARVPRODFIN');
    	prodFin.dataSourceFilter = [];
    	
    	var filtro = [
            {
                "name": "CDARVPROD",
                "operator": ">=",
                "value": prodIni.value()
            }
        ];
        
        prodFin.dataSourceFilter = filtro;
    };
    
    this.changeTemplate = function (field, fieldToChange) {
        var missingFields = [];
        var prop;
        
        if(field.value() == "T") {
            fieldToChange.readOnly = true;
            delete(fieldToChange.filterProperties.validations.required);
            fieldToChange.setValue("");
            
            if(field.name != 'TODOSNRPEDIDO' && field.name!= 'TODOSCDVENDEDOR' && !verificadorFields[fieldToChange.name] ) {
            	verificadorFields[fieldToChange.name] = true;
            	somadorFields++;
            }
            
            if(fieldToChange.name == 'NOTAFIS' || fieldToChange.name == 'NRPEDIDO') {
	            	templateManager.container.getWidget('relatorio_consumo_expedicao').getField('CDFILIAL').readOnly = false;
	            	templateManager.container.getWidget('relatorio_consumo_expedicao').getField('DTEXPEDICAO').readOnly = false;
            		templateManager.container.getWidget('relatorio_consumo_expedicao').getField('TODOSCLIENTE').readOnly = false;
            		templateManager.container.getWidget('relatorio_consumo_expedicao').getField('TODOSTIPOOP').readOnly = false;
	            	
	            	if(templateManager.container.getWidget('relatorio_consumo_expedicao').getField('TODOSCLIENTE').value() == 'L') {
	            		templateManager.container.getWidget('relatorio_consumo_expedicao').getField('CDCLIENTE').readOnly = false;
	            	}
	            	
	            	if(templateManager.container.getWidget('relatorio_consumo_expedicao').getField('TODOSTIPOOP').value() == 'L') {
	            		templateManager.container.getWidget('relatorio_consumo_expedicao').getField('TIPOOPER').readOnly = false;
	            	}
	            	
	            	if(fieldToChange.name == 'NRPEDIDO') {
	            		templateManager.container.getWidget('relatorio_consumo_expedicao').getField('TODASNOTAFIS').readOnly = false;
	            		if(templateManager.container.getWidget('relatorio_consumo_expedicao').getField('TODASNOTAFIS').value() == 'L') {
		            		templateManager.container.getWidget('relatorio_consumo_expedicao').getField('NOTAFIS').readOnly = false;
		            	}
	            	}
	            }
            
            templateManager.updateTemplate();
        } else {
            if(field.name != 'TODOSNRPEDIDO' && field.name!= 'TODOSCDVENDEDOR' && verificadorFields[fieldToChange.name]) {
            	verificadorFields[fieldToChange.name] = false;
        		somadorFields--;
            }
            
        	if(fieldToChange.name == 'NOTAFIS' && somadorFields < 4) {
    			verificadorFields[fieldToChange.name] = true;
    			somadorFields++;
        		
        		for (prop in verificadorFields) {
        			if(!verificadorFields[prop]) {
        				missingFields.push(templateManager.container.getWidget('relatorio_consumo_expedicao').getField(prop).label);
        			}
        		}
        		
    			templateManager.updateTemplate();
        		//ScreenService.showMessage('Os campos ' + missingFields.join(', ') + ' precisam ser preenchidos').then(function(){
        
        		var missing_fields = missingFields.join(', ');
				var var_precisa_ser_preenchido = "PRECISA_SER_PREENCHIDO";
				MessageService.showMessageByCode(var_precisa_ser_preenchido,{"MISSING": missing_fields}).then(function(){
        			field.setValue('T');
        			missingFields = [];
        		});
        		
        		
        	} else if (fieldToChange.name == 'NRPEDIDO' && somadorFields < 5) {
    			
    			for (prop in verificadorFields) {
        			if(!verificadorFields[prop]) {
        				missingFields.push(templateManager.container.getWidget('relatorio_consumo_expedicao').getField(prop).label);
        			}
        		}
        		
    			templateManager.updateTemplate();
        		//ScreenService.showMessage('Os campos ' + missingFields.join(', ') + ' precisam ser preenchidos').then(function(){

        		var missing_Fields = missingFields.join(', ');
				var Var_precisa_ser_preenchido = "PRECISA_SER_PREENCHIDO";
				MessageService.showMessageByCode(Var_precisa_ser_preenchido,{"MISSING": missing_Fields}).then(function(){
        			field.setValue('T');
        			missingFields = [];
        		});
    			
        	} else{
	            fieldToChange.readOnly = false;
	            fieldToChange.filterProperties.validations.required = true;
	            if(fieldToChange.name == 'NOTAFIS' || fieldToChange.name == 'NRPEDIDO') {
	            	templateManager.container.getWidget('relatorio_consumo_expedicao').getField('CDFILIAL').readOnly = true;
	            	templateManager.container.getWidget('relatorio_consumo_expedicao').getField('DTEXPEDICAO').readOnly = true;
	            	templateManager.container.getWidget('relatorio_consumo_expedicao').getField('TODOSCLIENTE').readOnly = true;
	            	templateManager.container.getWidget('relatorio_consumo_expedicao').getField('CDCLIENTE').readOnly = true;
	            	templateManager.container.getWidget('relatorio_consumo_expedicao').getField('TODOSTIPOOP').readOnly = true;
	            	templateManager.container.getWidget('relatorio_consumo_expedicao').getField('TIPOOPER').readOnly = true;
	            	if(fieldToChange.name == 'NRPEDIDO') {
	            		templateManager.container.getWidget('relatorio_consumo_expedicao').getField('TODASNOTAFIS').readOnly = true;
	            		templateManager.container.getWidget('relatorio_consumo_expedicao').getField('NOTAFIS').readOnly = true;
	            	}
	            }
	            templateManager.updateTemplate();
        	}
        }
    };
    
    this.prodIni = function(widget){
        
        var row = widget.currentRow;
        if (row.NMPRODINI){
            widget.getField('NMPRODFIN').readOnly = false;
            widget.getField('NMPRODFIN').readOnlyOnEdit = false;
        } else if(!row.NMPRODINI){ 
            widget.getField('NMPRODFIN').readOnly = true;
            widget.getField('NMPRODFIN').readOnlyOnEdit = true;
            widget.getField('NMPRODFIN').setValue("");
            widget.currentRow.NMPRODFIN = "";
        }
        widget.reload();
        //this.prodFin(widget);
    };
	
	this.prodFin = function(){
        var widget = templateManager.container.getActiveWidget();
        var row = widget.currentRow;

        if(row.NMPRODFIN){
            if(row.P_CDPRODUTOINI > row.P_CDPRODUTOFIN){
                ScreenService.showMessage("O codigo do produto inicial não pode ser maior que do final");
                return 0;
            }
        }
    };
	 /*global moment*/
	this.validaDatas = function (args) {
	    var expedicao = args.owner.field;
	    
	    if(expedicao.value().start != "" && expedicao.value().start != null) {
            args.row.DATAINICIAL = expedicao.value().start;
            args.row.DATAFINAL = expedicao.value().end;
	    } else {
	        args.row.DATAINICIAL = null;
	        args.row.DATAFINAL = null;
	    }
	    this.validaFields(templateManager.container.getWidget('relatorio_consumo_expedicao').getField('DATAINICIAL'));
	};
	
	//verificadorFields serve para a verificacao de fields necessarios aos campos NOTAFIS e NRPEDIDO
	this.validaFields = function(field) {
		if(field.value() != "" && field.value() != null && !verificadorFields[field.name]) {
			verificadorFields[field.name] = true;
			somadorFields++;
		} else if ((field.value() == "" || field.value() == null) && verificadorFields[field.name]) {
			verificadorFields[field.name] = false;
			somadorFields--;
		}
	};
	//modificar conteudo do field se dataSource nao entregar o esperado ao datasource da tela
	this.valueBuilder = function(field){
	    var filterRow = templateManager.container.getWidget('relatorio_consumo_expedicao').currentRow;
	    var valor = [];	
	    	
	    	for(var i = 0; i < filterRow.IDENTRSAIDOP.length ; i++) {
	    		valor.push(filterRow.IDENTRSAIDOP[i] + filterRow.CDTIPOOPER[i]);
	    	}
	    	
	        field.setValue(valor);
	};
	
	this.eventTest = function() {
		console.log('teste');
	};
	
	var nomes = {
	    "CDFILIAL": "P_CDFILIAL",
	    "DATAINICIAL": "P_DATAINI",
	    "DATAFINAL": "P_DATAFINAL",
	    "TODOSCLIENTE": "P_TODOS",
	    "CDCLIENTE": "P_CLIENTE",
	    "TODOSTIPOOP": "P_TTIPO",
	    "TIPOOPER": "P_TIPO",
	    "TODASNOTAFIS": "P_TNOTFIS",
	    "NOTAFIS": "P_NOTFIS",
	    "TODOSNRPEDIDO": "P_NRPEDTODOS2",
	    "NRPEDIDO": "P_NRPEDLISTA",
	    "TODOSCDVENDEDOR": "P_TVENDEDOR",
	    "CDVENDEDOR": "P_CDVENDEDOR",
	    "CDARVPRODINI": "P_PRODINIC",
	    "CDARVPRODFIN": "P_PRODFINAL",
	    "NVPROD": "P_NVPROD"
	};
	
	this.setDataSourcePedido = function(){
        var widget = templateManager.container.getActiveWidget();
        var row = widget.currentRow;
        var filtro = [
            {
	            name: "P_CDFILIAL",
                operator: "=",
                value: row.CDFILIAL
	        },
	        {
                name: "P_DATAINICIAL",
                operator: "=",
                value: row.DTEXPEDICAO.start
            },
            {
                name: "P_DATAFINAL",
                operator: "=",
                value: row.DTEXPEDICAO.end
            }
        ];
        
        //CDCLIENTE ----------------------------------
        if (row.CDCLIENTE && row.CDCLIENTE.length > 0) {
            var listaCLIENTE = '_'+row.CDCLIENTE.join('_')+'_';
            filtro.push(
                {
                    "name": "P_CDCLIENTE",
                    "operator": "=",
                    "value": listaCLIENTE
                },
                {
                    "name": "P_TCDCLIENTE",
                    "operator": "=",
                    "value": null
                }
            );
        } else {
            filtro.push(
                {
                    "name": "P_TCDCLIENTE",
                    "operator": "=",
                    "value": "T"
                }
            );
        }
        
        //NRLANCTONF ----------------------------------
        if (row.NOTAFIS && row.NOTAFIS.length > 0) {
            var listaNRLANCTONF = '_'+row.NOTAFIS.join('_')+'_';
            filtro.push(
                {
                    "name": "P_NRLANCTONF",
                    "operator": "=",
                    "value": listaNRLANCTONF
                },
                {
                    "name": "P_TNRLANCTONF",
                    "operator": "=",
                    "value": null
                }
            );
        } else {
            filtro.push(
                {
                    "name": "P_TNRLANCTONF",
                    "operator": "=",
                    "value": "T"
                }
            );
        }
        
       	General.callRestEngine("ped_expedicao#/crud/relatorio_consumo_na_expedicao_pedido", "FilterData", filtro).then( function(callback){
	 	 	widget.getField('NRPEDIDO').dataSource.data = callback.dataset.relatorio_consumo_na_expedicao_pedido;
	 	 	widget.getField('NRPEDIDO').reload();
	 	});
     	 
    };
	
    this.setDataSourceNotaFiscal = function(){
	 	var widget = templateManager.container.getActiveWidget();
	 	var row = widget.currentRow;

        var filtro = [
            {
                name: "P_CDFILIAL",
                operator: "=",
                value: row.CDFILIAL
            },
            {
                name: "P_DATAINICIAL",
                operator: "=",
                value: row.DTEXPEDICAO.start
            },
            {
                name: "P_DATAFINAL",
                operator: "=",
                value: row.DTEXPEDICAO.end
            }
        ];
        
        //CDCLIENTE ----------------------------------
        if (row.CDCLIENTE && row.CDCLIENTE.length > 0) {
            var listaCLIENTE = '_'+row.CDCLIENTE.join('_')+'_';
            filtro.push(
                {
                    "name": "P_CDCLIENTE",
                    "operator": "=",
                    "value": listaCLIENTE
                },
                {
                    "name": "P_TCDCLIENTE",
                    "operator": "=",
                    "value": null
                }
            );
        } else {
            filtro.push(
                {
                    "name": "P_TCDCLIENTE",
                    "operator": "=",
                    "value": "T"
                }
            );
        }
        
	 	//CDTIPOOPER ----------------------------------
        if (row.CDTIPOOPER && row.CDTIPOOPER.length > 0) {
            var listaTIPOOPER = '_'+row.CDTIPOOPER.join('_')+'_';
            filtro.push(
                {
                    "name": "P_CDTIPOOPER",
                    "operator": "=",
                    "value": listaTIPOOPER
                },
                {
                    "name": "P_TCDTIPOOPER",
                    "operator": "=",
                    "value": null
                }
            );
        } else {
            filtro.push(
                {
                    "name": "P_TCDTIPOOPER",
                    "operator": "=",
                    "value": "T"
                }
            );
        }
        
        General.callRestEngine("ped_expedicao#/crud/relatorio_consumo_na_expedicao_notafiscal", "FilterData", filtro).then( function(callback){
	 	 	widget.getField('NOTAFIS').dataSource.data = callback.dataset.relatorio_consumo_na_expedicao_notafiscal;
	 	 	widget.getField('NOTAFIS').reload();
	 	});

	 };
	
	// dadaSourceFilter exp00600
	this.setDataSourceFilterApply = function(args){
	    var valuesWidget = templateManager.container.factoredWidgets.filter((widget) => {return widget._filteredWidgetId == args.owner.id;});
	    var row = valuesWidget[0].currentRow;
	    var filterApply = [];
	    if(valuesWidget[0].isValid()){
	        filterApply.push(
    	        {
    	            name: "P_CDFILIAL",
                    operator: "=",
                    value: row.CDFILIAL
    	        },
    	        {
                    name: "P_DATAINI",
                    operator: "=",
                    value: row.DTEXPEDICAO.start
                },
                {
                    name: "P_DATAFINAL",
                    operator: "=",
                    value: row.DTEXPEDICAO.end
                },
                {
                    name: "P_PRODINIC",
                    operator: "=",
                    value: row.P_PRODINI
                },
                {
                    name: "P_PRODFINAL",
                    operator: "=",          
                    value: row.P_PRODFIN +"ZZZZZZZZZ"
                }
                
            );
	    }
	    
	    //CDCLIENTE ----------------------------------
	    if (row.CDCLIENTE && row.CDCLIENTE.length > 0) {
            var listaCLIENTE = '_'+row.CDCLIENTE.join('_')+'_';
            filterApply.push(
                {
                    "name": "P_CDCLIENTE",
                    "operator": "=",
                    "value": listaCLIENTE
                }
            );
        } else {
            filterApply.push(
                {
                    "name": "P_TCDCLIENTE",
                    "operator": "=",
                    "value": "T"
                }
            );
        }
	    
	    //CDTIPOOPER ----------------------------------
	    if (row.CDTIPOOPER && row.CDTIPOOPER.length > 0) {
            var listaCDTIPOOPER = '_'+row.CDTIPOOPER.join('_')+'_';
            filterApply.push(
                {
                    "name": "P_CDTIPOOPER",
                    "operator": "=",
                    "value": listaCDTIPOOPER
                }
            );
        } else {
            filterApply.push(
                {
                    "name": "P_TCDTIPOOPER",
                    "operator": "=",
                    "value": "T"
                }
            );
        }
	    
        //NOTAFIS -------------------------------------
        if (row.NOTAFIS && row.NOTAFIS.length > 0) {
            var listaNOTAFIS = '_'+row.NOTAFIS.join('_')+'_';
            filterApply.push(
                {
                    "name": "P_NOTAFIS",
                    "operator": "=",
                    "value": listaNOTAFIS
                }
            );
        } else {
            filterApply.push(
                {
                    "name": "P_TNOTAFIS",
                    "operator": "=",
                    "value": "T"
                }
            );
        }
        
        //NRPEDLISTA ----------------------------------
        if (row.NRPEDIDO && row.NRPEDIDO.length > 0) {
            var listaNRPEDIDO = '_'+row.NRPEDIDO.join('_')+'_';
            filterApply.push(
                {
                    "name": "P_NRPEDLISTA",
                    "operator": "=",
                    "value": listaNRPEDIDO
                }
            );
        } else {
            filterApply.push(
                {
                    "name": "P_NRPEDTODOS",
                    "operator": "=",
                    "value": "T"
                }
            );
        }
        
        //CDVENDEDOR ----------------------------------
        if (row.CDVENDEDOR && row.CDVENDEDOR.length > 0) {
            var listaCDVENDEDOR = '_'+row.CDVENDEDOR.join('_')+'_';
            filterApply.push(
                {
                    "name": "P_CDVENDEDOR",
                    "operator": "=",
                    "value": listaCDVENDEDOR
                }
            );
        } else {
            filterApply.push(
                {
                    "name": "P_TCDVENDEDOR",
                    "operator": "=",
                    "value": "T"
                }
            );
        }
        
        args.owner.dataSourceFilter = [];      
        args.owner.dataSourceFilter = filterApply;
        
        args.owner.container.getWidget('relatorio_consumo_expedicao').reload();
    };
}


Configuration(function(ContextRegister) {
    ContextRegister.register('exp00600_relatorio_consumo_na_expedicao_Controller', exp00600_relatorio_consumo_na_expedicao_Controller);
});